#include "GameDataStruct.h"
#include "dijkstra.h"
#include "DijkstraCastle.h"


static Dijkstra  m_dijkstra;  //_CNXg@vZNX
static Node*     m_select;    //Im[hiڑŎgj



void InitCastleNodeAndEdge() {
	m_select = NULL;

	// m[hʒuڑC|[g
	m_dijkstra.Inport();
}


void SetStartCastleNode(int iCastleID ) {

	// ID͈̓`FbN
	if (! (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) ) {
		return;
	}

	Node* n = m_dijkstra.Query(iCastleID);

	if ( n != NULL ) {
		m_dijkstra.SelctStart(n);
	}
}

void SetGoalCastleNode(int iCastleID ) {

	// ID͈̓`FbN
	if (! (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) ) {
		return;
	}

	Node* n = m_dijkstra.Query(iCastleID);

	if ( n != NULL ) {
		m_dijkstra.SelctGoal(n);
	}
}


void RemoveCastleNode(int iCastleID) {
	// ID͈̓`FbN
	if (! (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) ) {
		return;
	}

	//m[hm[hڑ폜
	Node* n = m_dijkstra.Query(iCastleID);

	if ( n != NULL ) {
		m_dijkstra.Remove(n);
	}

	NodePair pair;
	if ( m_dijkstra.QueryLineOnNodePair( &pair, n->x, n->y) ) {
		m_dijkstra.RemoveConnect( pair.n1, pair.n2 );
	}
}


vector<int> SearchCastleWayRoot() {
	vector<int> iWayCastleIDList; // oH̏ID

	// oHf[^ݒ
	m_dijkstra.SearchRoot();

	Node* curr = m_dijkstra.GetStartNode();
	iWayCastleIDList.push_back( curr->GetCastleID() ); // X^[ĝ͕K

	// S[ւƌq鎟̃m[hȂ΁c
	while ( curr->toGoal ) {
		// ̃m[h̃m[hƂB
		curr = curr->toGoal;
		iWayCastleIDList.push_back( curr->GetCastleID() ); // ̔ԍ
	}

	return iWayCastleIDList;
	
}


// w̏邩瓹qĂאڏ̃Xg𓾂B
vector<int> getWayConnectCastles(int iCastleID) {
	vector<int> connect_castle_list;

	// GbW̃X^[gn_́AS[n_ɎgiCastleIDB
	for ( int iEdgeID=0; iEdgeID<N6PCASTLE_EDGE_NUM; iEdgeID++ ) {
		// ԍe1ƈvAe2A
		if ( iCastleID == nb6castle_edges[iEdgeID].e1 ) {
			connect_castle_list.push_back( nb6castle_edges[iEdgeID].e2 );
		}
		// te2ƈvAe1A
		else if ( iCastleID == nb6castle_edges[iEdgeID].e2 ) {
			connect_castle_list.push_back( nb6castle_edges[iEdgeID].e1 );
		}
	}

	return connect_castle_list;
}





