#include "GameDataStruct.h"

// ̔N𓾂
int getYearsOld(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		return nb6year.year - nb6bushou[iBushouID].birth + 1;
	}
	return 0xFF;
}


// yERnESCER̓K𐔒lœB(0=E,1=D,2=C,3=B,4=A,5=S)
int getBushouAptitude(int iBushouID, APTITUDE eAptitude) {
	if (eAptitude == APTITUDE_ASIGARU) {
		return nb6bushou[iBushouID].aptitudeasi;
	}
	else if (eAptitude == APTITUDE_KIBA) {
		return nb6bushou[iBushouID].aptitudekib;
	}
	else if (eAptitude == APTITUDE_TEPPOU) {
		// SC͂Q̃tBbgtB[hɕĂ܂Ă̂ŁAvZ
		int ret = nb6bushou[iBushouID]._aptitudegun_lo << 2;
		ret += nb6bushou[iBushouID]._aptitudegun_hi;
		return ret;
	}
	else if (eAptitude == APTITUDE_SUIGUN) {
		return nb6bushou[iBushouID].aptitudesui;
	}
	return -1;
}



// yERnESCER̓K𐔒lŐݒ肷B(0=E,1=D,2=C,3=B,4=A,5=S)
void setBushouAptitude(int iBushouID, APTITUDE eAptitude, int iTekisei) {
	if (eAptitude == APTITUDE_ASIGARU) {
		nb6bushou[iBushouID].aptitudeasi = iTekisei;
	}
	else if (eAptitude == APTITUDE_KIBA) {
		nb6bushou[iBushouID].aptitudekib = iTekisei;
	}
	else if (eAptitude == APTITUDE_TEPPOU) {
		// SC͂Q̃tBbgtB[hɕĂ܂Ă̂ŁAvZ
		nb6bushou[iBushouID]._aptitudegun_hi = iTekisei & 0x0003;  // 0b000000HH
		nb6bushou[iBushouID]._aptitudegun_lo = iTekisei >> 2;      // 0b00000L00
	}
	else if (eAptitude == APTITUDE_SUIGUN) {
		nb6bushou[iBushouID].aptitudesui = iTekisei;
	}
}



// ̓Ɨl𓾂
int getBushouIndependence(int iBushouID) {
	// SC͂Q̃tBbgtB[hɕĂ܂Ă̂ŁAvZ
	int ret = nb6bushou[iBushouID]._independence_lo << 2;
	ret += nb6bushou[iBushouID]._independence_hi;
	return ret;
}

// ̓Ɨlݒ肷
void setBushouIndependence(int iBushouID, int iIndependence) {
	nb6bushou[iBushouID]._independence_hi = iIndependence & 0x0003;  // 0b000000HH
	nb6bushou[iBushouID]._independence_lo = iIndependence >> 2;      // 0b00000L00
}

// ̐퓬l
int getBushouBat(int iBushouID) {
	// ˁ~m/2000
	return int(nb6bushou[iBushouID].maxbat * (float(nb6bushou[iBushouID].expbat) / float(2000)));
}
// ̒qdl
int getBushouInt(int iBushouID) {
	// ˁ~m/2000
	return int(nb6bushou[iBushouID].maxint * (float(nb6bushou[iBushouID].expint) / float(2000)));
}
// ̐l
int getBushouGov(int iBushouID) {
	// ˁ~m/2000
	return int(nb6bushou[iBushouID].maxgov * (float(nb6bushou[iBushouID].expgov) / float(2000)));
}


// ƕȂǂ܂߂Ȃf̐˔\
int getBushouPureGovMax(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// ^CvF0 q  1   2   3   4 ԓ  
			if (0 <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 4) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸l
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}

		int maxgov = nb6bushou[iBushouID].maxgov;
		return (maxgov - upparam) > 0 ? (maxgov - upparam) : 1;
	}
	else {
		return 0;
	}
}

// ƕȂǂ܂߂Ȃf̐퓬˔\
int getBushouPureBatMax(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// 퓬^CvF5   6   7   8 n  9   A wHD   
			if (5 <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0xA) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}

		int maxbat = nb6bushou[iBushouID].maxbat;
		return (maxbat - upparam) > 0 ? (maxbat - upparam) : 1;
	}
	else {
		return 0;
	}
}

// ƕȂǂ܂߂Ȃf̒qd˔\
int getBushouPureIntMax(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// qd^CvFB q{  C Ԗ{
			if (0xB <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0xC) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}

		int maxint = nb6bushou[iBushouID].maxint;
		return (maxint - upparam) > 0 ? (maxint - upparam) : 1;
	}
	else {
		return 0;
	}
}

// ƕȂǂ܂߂Ȃf̖]
int getBushouPureAmbition(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// ]^CvFD   E nV  F ؎v  10 n  11 \  12   13 ʎ蔠  14 r[ht  15 ዾ  16 \  17 
			if (0xD <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0x17) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}

		int ambition = nb6bushou[iBushouID].ambition;
		return (ambition - upparam) > 0 ? (ambition - upparam) : 1;
	}
	else {
		return 0;
	}
}

// ʂȂǂ܂߂Ȃf̖
int getBushouPureCharm(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKaniID = 0; iKaniID < GAMEDATASTRUCT_KANI_NUM; iKaniID++) {
			// Ǝw蕐v
			if (nb6kani[iKaniID].attach == iBushouID + 1) {
				// ܂łōő̏㏸n
				if (nb6kani[iKaniID].param > upparam) {
					upparam = nb6kani[iKaniID].param;
				}
			}
		}

		int charm = nb6bushou[iBushouID].charm;
		return (charm - upparam) > 0 ? (charm - upparam) : 1;
	}
	else {
		return 0;
	}
}



// ƕɂ鐭̏グ
int getBushouGovMaxUpByKahou(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// ^CvF0 q  1   2   3   4 ԓ  
			if (0 <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 4) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸l
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}
		return upparam;
	}
	else {
		return 0;
	}
}

// ƕɂ퓬̏グ
int getBushouBatMaxUpByKahou(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// 퓬^CvF5   6   7   8 n  9   A wHD   
			if (5 <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0xA) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}
		return upparam;
	}
	else {
		return 0;
	}
}

// ƕɂqd̏グ
int getBushouIntMaxUpByKahou(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// qd^CvFB q{  C Ԗ{
			if (0xB <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0xC) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}

		return upparam;
	}
	else {
		return 0;
	}
}

// ƕɂ]̏グ
int getBushouAmbitionUpByKahou(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKahouID = 0; iKahouID < GAMEDATASTRUCT_KAHOU_NUM; iKahouID++) {
			// ]^CvFD   E nV  F ؎v  10 n  11 \  12   13 ʎ蔠  14 r[ht  15 ዾ  16 \  17 
			if (0xD <= nb6kahou[iKahouID].type && nb6kahou[iKahouID].type <= 0x17) {
				// Ǝw蕐v
				if (nb6kahou[iKahouID].attach == iBushouID + 1) {
					// ܂łōő̏㏸n
					if (nb6kahou[iKahouID].param > upparam) {
						upparam = nb6kahou[iKahouID].param;
					}
				}
			}
		}
		return upparam;
	}
	else {
		return 0;
	}
}


// ʂɂ閣͂̏グ
int getBushouCharmUpByKani(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		int upparam = 0; // ㏸l
		for (int iKaniID = 0; iKaniID < GAMEDATASTRUCT_KANI_NUM; iKaniID++) {
			// Ǝw蕐v
			if (nb6kani[iKaniID].attach == iBushouID + 1) {
				// ܂łōő̏㏸n
				if (nb6kani[iKaniID].param > upparam) {
					upparam = nb6kani[iKaniID].param;
				}
			}
		}
		return upparam;
	}
	else {
		return 0;
	}
}




// ID畐ID߂Bs0xFFFF
int getBushouIDFromFaceID(int iFaceID) {
	for (int iBushouID = 0; iBushouID<GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {
		if (nb6bushouname[iBushouID].number == iFaceID) {
			return iBushouID;
		}
	}
	return 0xFFFF;
}


// w蕐̔iBushouID𓾂BȂꍇɂ́A0xFFFFԂĂB
int getHanryoBushouID(int iBushouID) {

	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {

		// w̔̕
		int iBushouIDSpouse = nb6bushou[iBushouID].spouse; //

														   // ĂȂ
		if (iBushouIDSpouse == 0xFF) {
			return 0xFFFF;
		}

		int iTsumaBushouID = iBushouIDSpouse + 500;

		// ̔ԍgA͍ȑ̗
		if (iTsumaBushouID == iBushouID) {
			for (int i = 0; i<GAMEDATASTRUCT_BUSHOU_NUM; i++) {
				// gȊOŁAԍĂ̂A̕
				if (i != iBushouID &&  nb6bushou[i].spouse == iBushouIDSpouse) {
					return i;
				}
			}
			return 0xFFFF;

			// ͕vBȂɂԍݒ肳Ă邩mFB
		}
		else {
			if (nb6bushou[iTsumaBushouID].spouse == iBushouIDSpouse) {
				return iTsumaBushouID;
				// Ȃݒ肳ĂȂcBŃf[^ĂB
			}
			else {
				return 0xFFFF;
			}
		}
	}
	else {
		return 0xFFFF;
	}
}

// P(̍̕Ȋ܂)Aw̕ƌA֌W͈ؑ삳ȂB
bool setHimeMarriage(int iHimeID, int iOttoID, BOOL withKodokuDeath) {

	// lBAEgB
	if (iHimeID == iOttoID) { return false; }

	// vƕPK͈̔͂ɓĂȂ΃AEg
	if (0 <= iOttoID && iOttoID < GAMEDATASTRUCT_BUSHOU_NUM &&
		500 <= iHimeID && iHimeID < GAMEDATASTRUCT_BUSHOU_NUM) {

		// P̂hc̕APłȂȂ΁AAEg
		if (nb6bushouname[iHimeID].State != 5) { // 
			return false;
		}

		int _new_spouse = iHimeID - 500; // ȂɓׂĺAPԍyzpz-500

										 // łɗ҂͕vwłAKvB
		if (nb6bushou[iOttoID].spouse == _new_spouse &&  nb6bushou[iHimeID].spouse == _new_spouse) {
			return true;
		}

		// vłɌĂ邩AĂ痣
		int _otto_old_spouse = nb6bushou[iOttoID].spouse; //
														  // 
		setHimeDivorce(_otto_old_spouse + 500, withKodokuDeath);

		nb6bushouname[iHimeID].State = 5; // VWǓƏŎSȂ̂ŕPɖ߂B

		int _tuma_old_spouse = nb6bushou[iHimeID].spouse; //
		setHimeDivorce(_tuma_old_spouse + 500, withKodokuDeath);

		nb6bushouname[iHimeID].State = 5; // VWǓƏŎSȂ̂ŕPɖ߂B

										  // gYɂȂ̂ŉ߂Č
		nb6bushou[iOttoID].spouse = _new_spouse;
		nb6bushou[iHimeID].spouse = _new_spouse;

		// 喼ƂoĂ
		int OldDaimyoID = nb6bushou[iHimeID].attach;

		// v̑喼̕ɐg񂹂
		nb6bushou[iHimeID].attach = nb6bushou[iOttoID].attach;

		// v̂̂ŏ㏑B
		strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iOttoID].familyname);

		// ʁA喼Ƃω̂ł΁AmNZbg
		if (OldDaimyoID != nb6bushou[iHimeID].attach) {
			nb6bushou[iHimeID].work = 0;
		}

		return true;
	}

	return false;
}


// w̕P𗣍B
bool setHimeDivorce(int iHimeID, BOOL withKodokuDeath) {

	// vƕPK͈̔͂ɓĂȂ΃AEg
	if (500 <= iHimeID && iHimeID < GAMEDATASTRUCT_BUSHOU_NUM) {


		// P̂hc̕APłȂȂ΁AAEg
		if (nb6bushouname[iHimeID].State != 5) {
			return false;
		}

		int _tuma_spouse = nb6bushou[iHimeID].spouse; //

													  // XĂȂB
		if (_tuma_spouse == 0xFF) {
			return false;
		}

		// ҂̌NA
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {
			// v͍Ȃł
			if (nb6bushou[iBushouID].spouse == _tuma_spouse) {
				// 
				nb6bushou[iBushouID].spouse = 0xFF;
				// vƍ2lƂl0xFFɂKv̂ŁAbreakȂƁB
				// łɃf[^ɃS~ĂꍇłNA
			}
		}


		// 喼ƂoĂ
		int OldDaimyoID = nb6bushou[iHimeID].attach;

		// ȉ̐gln̏́AvOŏo邾ĂƂ|B
		// ɂœK؂ȑ喼ɋA]ڂłȂƂĂAVċL̃vO{̂Gߎɂ́AK؂ȑ喼ɋA鏈sB

		// ̂ŏ喼ύXKvB܂Ae喼Ă邩ǂB
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {

			// 喼̂c
			if (nb6bushouname[iBushouID].State == 0) { // 喼

													   // ̐e喼ĂB
				if (nb6bushou[iHimeID].parent < 5000) {
					// ̑喼͕P̐e
					if (nb6bushouname[iBushouID].number == nb6bushou[iHimeID].parent) {

						// ɐg񂹂
						nb6bushou[iHimeID].attach = nb6bushou[iBushouID].attach;

						strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iBushouID].familyname);
						break;
					}
				}
			}
		}


		// e喼ĂȂƂAel(Zo)喼Ă邩ǂB
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {

			// 喼̂c
			if (nb6bushouname[iBushouID].State == 0) { // 喼

													   // eB
				if (nb6bushou[iHimeID].parent < 5000) {
					if (nb6bushou[iBushouID].parent == nb6bushou[iHimeID].parent) {

						// ɐg񂹂
						nb6bushou[iHimeID].attach = nb6bushou[iBushouID].attach;

						strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iBushouID].familyname);
						break;
					}
				}
			}
		}

		// eZ킪喼ĂȂĂA傪喼Ă̂ł͂ȂB
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {

			// 喼̂c
			if (nb6bushouname[iBushouID].State == 0) { // 喼

													   // eB
				if (nb6bushou[iHimeID].blood != 0xFF) {
					if (nb6bushou[iBushouID].blood == nb6bushou[iHimeID].blood) {

						// ɐg񂹂
						nb6bushou[iHimeID].attach = nb6bushou[iBushouID].attach;

						strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iBushouID].familyname);
						break;
					}
				}
			}
		}

		bool isTengaiKodoku = true;
		// 喼łȂƂAeǂɂ̂ł͂ȂH
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {

			// ̐e
			if (nb6bushou[iHimeID].parent < 5000) {
				if (nb6bushouname[iBushouID].number == nb6bushou[iHimeID].parent) {

					// ɐg񂹂
					nb6bushou[iHimeID].attach = nb6bushou[iBushouID].attach;

					strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iBushouID].familyname);

					// g肪̂œVWǓƂł͂Ȃ
					isTengaiKodoku = false;
					break;
				}
			}
		}

		// 喼łȂƂAel(Zo)ǂɂ̂ł͂ȂH
		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {

			// eB
			if (nb6bushou[iHimeID].parent < 5000) {
				if (nb6bushou[iBushouID].parent == nb6bushou[iHimeID].parent) {

					// ɐg񂹂
					nb6bushou[iHimeID].attach = nb6bushou[iBushouID].attach;

					strcpy(nb6bushouname[iHimeID].familyname, nb6bushouname[iBushouID].familyname);

					// g肪̂œVWǓƂł͂Ȃ
					isTengaiKodoku = false;
					break;
				}
			}
		}


		// ʁA喼Ƃω̂ł΁AmNZbg
		if (OldDaimyoID != nb6bushou[iHimeID].attach) {
			nb6bushou[iHimeID].work = 0;
		}

		if (withKodokuDeath) {
			if (isTengaiKodoku) {
				nb6bushouname[iHimeID].State = 7; // VWǓƂɂȂ玀SƂB
			}
		}

		return true;
	}

	return false;
}




// State   State Ql
bool setGenekiToRounin(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {

		if (nb6bushouname[iBushouID].State == 2) { // 𕐏̏ꍇB

												   // Y̋邪Ƃ񂪊i[ĂB([U[ɂĉĂȂ)
			int iCastleID = nb6bushou[iBushouID].castle - 1;
			if (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) {
				if (nb6castle[iCastleID].master == 0xFFFF) { return false; } // NXgĂ̂ɒNĂȂBȂBreturn;

																			 // ̒lύX
				{
					nb6bushouname[iBushouID].State = 4; // ԂQlƂB

					nb6bushouname[iBushouID].position = 6; // g𑫌yƂB

					nb6bushou[iBushouID].attach = 0xFFFF; // 喼ɏȂB
					nb6bushou[iBushouID].gundan = 0xFFFF; // RcɏȂB
					nb6bushou[iBushouID].loyal = 50; // 50ƂB
					nb6bushou[iBushouID].work = 0; // dN0ƂB

					nb6bushou[iBushouID].rise = 0xFFFF; // ȂƂB
					nb6bushou[iBushouID].bRise = 0; // ȂB

					nb6bushou[iBushouID].soldier = 0; // 0ƂB
					nb6bushou[iBushouID].training = 0; // P0ƂB
					nb6bushou[iBushouID].solloyal = 0; // 0ƂB
					nb6bushou[iBushouID].form = 0; // yƂB

					nb6bushou[iBushouID].merits = 0; // M0ƂB
				}

				/* @
				
				---

				Ƃ̂

				--

				ƂB
				*/


				// Qlɂ́A܏傾
				if (nb6castle[iCastleID].master - 1 == iBushouID) {
					nb6castle[iCastleID].master = nb6bushou[iBushouID].next; // nextɂB
				}

				// prev͗LȕB
				if (0 < nb6bushou[iBushouID].prev && nb6bushou[iBushouID].prev <= GAMEDATASTRUCT_BUSHOU_NUM) {

					// ł͂ȂŁA
					// PO̐l̎̃N悪g̏ꍇ
					if (nb6bushou[iBushouID].prev != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].prev - 1)].next == iBushouID + 1) {
						// ł͂ȂA̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].prev - 1)].next = nb6bushou[iBushouID].next;
					}
				}

				// next͗LȕB
				if (0 < nb6bushou[iBushouID].next && nb6bushou[iBushouID].next <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// P̐l̑ÕN悪g̏ꍇ
					if (nb6bushou[iBushouID].next != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].next - 1)].prev == iBushouID + 1) {
						// ł͂ȂAO̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].next - 1)].prev = nb6bushou[iBushouID].prev;
					}
				}


				/* @

				-

				Ƃ̂

				--

				ƂB
				*/

				// QlƂĂ݂ȂAnext́AݘQlXg̐擪̐l
				nb6bushou[iBushouID].next = nb6castle[iCastleID].ronin; // ݂̐擪̐l̎̐l

																		// nextLȕȂ΁c
				if (0 < nb6castle[iCastleID].ronin && nb6castle[iCastleID].ronin <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// ̐lprev
					nb6bushou[nb6castle[iCastleID].ronin - 1].prev = iBushouID + 1;

				}
				nb6bushou[iBushouID].prev = 0xFFFF; // prev͋Ȃ

				nb6castle[iCastleID].ronin = iBushouID + 1; // ̘Ql̐擪ɂB

				return true;

			}
		}
	}

	return false;
}


// State Ql  State 
bool setRouninToGeneki(int iBushouID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		if (nb6bushouname[iBushouID].State == 4) { // Ql̏ꍇB
												   // Y̋邪Ƃ񂪊i[ĂB([U[ɂĉĂȂ)
			int iCastleID = nb6bushou[iBushouID].castle - 1;
			if (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) {

				if (nb6castle[iCastleID].ronin == 0xFFFF) { return false; } // NXgĂ̂QlNȂƂɂȂĂBȂBreturn;
				if (nb6castle[iCastleID].attach == 0xFFFF) { return false; } // Y̏邪ǂ̌RcɂĂȂꍇAQlƂ͏oȂB
																			 // ȂȂA͑喼邱ƂӖ邩B
				int iAttachGundanID = nb6castle[iCastleID].attach - 1;
				int iAttachDaimyoID = -1;
				if (0 <= iAttachGundanID && iAttachGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {
					iAttachDaimyoID = nb6gundan[iAttachGundanID].attach - 1;
				}
				else {
					return false;
				}
				if (!(0 <= iAttachDaimyoID && iAttachDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM)) {
					return false;
				}

				// ݂̏̏傩ANXgHĂ
				int iLinkEndBusyouID = nb6castle[iCastleID].master;
				int iSafetyCnt = 0;
				while (true) {
					// Z[teBJEg\ĂB
					if (iSafetyCnt > GAMEDATASTRUCT_BUSHOU_NUM) {
						return false;
					}

					// 傪ȂȂ΁AI
					if (iLinkEndBusyouID == 0xFFFF) {
						break;
					}

					// ݂́̕AnextLł͂Ȃ΁A݂̕Ō̐lBIB
					if (nb6bushou[iLinkEndBusyouID - 1].next == 0xFFFF) {
						break;

						// ݂̐lLłB
					}
					else {
						// NXg̐lƂB
						if (0 < iLinkEndBusyouID && iLinkEndBusyouID <= GAMEDATASTRUCT_BUSHOU_NUM) {
							iLinkEndBusyouID = nb6bushou[iLinkEndBusyouID - 1].next;
						}
					}
				}

				// ̒lύX
				{
					nb6bushouname[iBushouID].State = 2; // ԂƂB

					nb6bushou[iBushouID].attach = iAttachDaimyoID + 1; // 喼ɏB
					nb6bushou[iBushouID].gundan = iAttachGundanID + 1; // RcɏB
					nb6bushou[iBushouID].loyal = 50; // 50ƂB

					nb6bushou[iBushouID].rise = 0xFFFF; // ȂƂB
					nb6bushou[iBushouID].bRise = 0; // ȂB

					nb6bushou[iBushouID].soldier = 0; // 0ƂB
					nb6bushou[iBushouID].training = 0; // P0ƂB
					nb6bushou[iBushouID].solloyal = 0; // 0ƂB
					nb6bushou[iBushouID].form = 0; // yƂB

					nb6bushouname[iBushouID].position = 6; // g𑫌yƂB
					//------------------------------------------------------
				}

				/* @
				
				---

				Ƃ̂

				--

				ƂB
				*/


				// ɂ́Aܐ擪
				if (nb6castle[iCastleID].ronin - 1 == iBushouID) {
					nb6castle[iCastleID].ronin = nb6bushou[iBushouID].next; // nextɂB
				}

				// prev͗LȕB
				if (0 < nb6bushou[iBushouID].prev && nb6bushou[iBushouID].prev <= GAMEDATASTRUCT_BUSHOU_NUM) {

					// 擪ł͂ȂŁA
					// PO̐l̎̃N悪g̏ꍇ
					if (nb6bushou[iBushouID].prev != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].prev - 1)].next == iBushouID + 1) {
						// ł͂ȂA̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].prev - 1)].next = nb6bushou[iBushouID].next;
					}
				}

				// next͗LȕB
				if (0 < nb6bushou[iBushouID].next && nb6bushou[iBushouID].next <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// P̐l̑ÕN悪g̏ꍇ
					if (nb6bushou[iBushouID].next != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].next - 1)].prev == iBushouID + 1) {
						// ł͂ȂAO̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].next - 1)].prev = nb6bushou[iBushouID].prev;
					}
				}


				/* @

				-

				Ƃ̂

				--

				ƂB
				*/


				// ͌ƂĈԍŌɂBnext͋Ȃ
				nb6bushou[iBushouID].next = 0xFFFF;

				// ́AɂȂƂƂɁAɂȂׂȂ΁c
				if (iLinkEndBusyouID == 0xFFFF) {
					nb6bushou[iBushouID].prev = 0xFFFF; // ̑O̐l͋Ȃ

					nb6castle[iCastleID].master = iBushouID + 1; // ͎

																 // NXg̈ԍŌɂԂ牺ׂB
				}
				else {

					nb6bushou[iLinkEndBusyouID - 1].next = iBushouID + 1; // NXg̍Ōnext

					nb6bushou[iBushouID].prev = iLinkEndBusyouID; // ̑O̐ĺÃNXg̍Ō̐l
				}
				return true;

			}
		}
	}

	return false;
}


bool _setBushouTransportRonin(int iBushouID, int iNewCastleID) {
	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {
		if (nb6bushouname[iBushouID].State == 4) { // Ql̏ꍇB
												   // Y̋邪Ƃ񂪊i[ĂB([U[ɂĉĂȂ)
			int iCastleID = nb6bushou[iBushouID].castle - 1;

			if (iCastleID == iNewCastleID) { return true; } // z悪牽Kv͂ȂƂ݂ȂB

			if (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) {

				if (nb6castle[iCastleID].ronin == 0xFFFF) { return false; } // NXgĂ̂QlNȂƂɂȂĂBȂBreturn;

																			// ̒lύX
				{
					// ]ɕύXB
					nb6bushou[iBushouID].castle = iNewCastleID + 1;
				}

				/* @
				
				---

				Ƃ̂

				--

				ƂB
				*/


				// ]́Aܐ擪
				if (nb6castle[iCastleID].ronin - 1 == iBushouID) {
					nb6castle[iCastleID].ronin = nb6bushou[iBushouID].next; // nextɂB
				}

				// prev͗LȕB
				if (0 < nb6bushou[iBushouID].prev && nb6bushou[iBushouID].prev <= GAMEDATASTRUCT_BUSHOU_NUM) {

					// 擪ł͂ȂŁA
					// PO̐l̎̃N悪g̏ꍇ
					if (nb6bushou[iBushouID].prev != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].prev - 1)].next == iBushouID + 1) {
						// ł͂ȂA̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].prev - 1)].next = nb6bushou[iBushouID].next;
					}
				}

				// next͗LȕB
				if (0 < nb6bushou[iBushouID].next && nb6bushou[iBushouID].next <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// P̐l̑ÕN悪g̏ꍇ
					if (nb6bushou[iBushouID].next != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].next - 1)].prev == iBushouID + 1) {
						// ł͂ȂAO̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].next - 1)].prev = nb6bushou[iBushouID].prev;
					}
				}

				/* @

				-

				Ƃ̂

				--

				ƂB
				*/

				// QlƂĂ݂ȂAnext́AݘQlXg̐擪̐l
				nb6bushou[iBushouID].next = nb6castle[iNewCastleID].ronin; // ]݂̌̐擪̐l̎̐l

																		   // nextLȕȂ΁c
				if (0 < nb6castle[iNewCastleID].ronin && nb6castle[iNewCastleID].ronin <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// ̐lprev
					nb6bushou[nb6castle[iNewCastleID].ronin - 1].prev = iBushouID + 1;
				}
				nb6bushou[iBushouID].prev = 0xFFFF; // prev͋Ȃ

				nb6castle[iNewCastleID].ronin = iBushouID + 1; // ̘Ql̐擪ɂB

				return true;
			}
		}
	}

	return false;
}


bool setBushouTransport(int iBushouID, int iNewCastleID) {

	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {

		// ̋ƐV
		int iCastleID = nb6bushou[iBushouID].castle - 1;
		if (iCastleID == iNewCastleID) { return true; } // ꏊƁA]悪Ȃ牽Kv͂ȂB

														// Ql̏ꍇ͈ړ]邾
		if (nb6bushouname[iBushouID].State == 4) { // Ql̏ꍇB
			return _setBushouTransportRonin(iBushouID, iNewCastleID);

			// ̏ꍇ́AQlĂAړ]āA܂(\ł)ɖ߂B
			// 邾ƘQl̂܂܈ړ]邱ƂƂȂB
		}
		else if (nb6bushouname[iBushouID].State == 2) { // 𕐏ł
			int _merits = nb6bushou[iBushouID].merits;
			int _work = nb6bushou[iBushouID].work;
			int _position = nb6bushouname[iBushouID].position;
			int _loyal = nb6bushou[iBushouID].loyal;
			int _soldier = nb6bushou[iBushouID].soldier;
			int _training = nb6bushou[iBushouID].training;
			int _solloyal = nb6bushou[iBushouID].solloyal;
			int _form = nb6bushou[iBushouID].form;
			int _attach = nb6bushou[iBushouID].attach;
			int _rise = nb6bushou[iBushouID].rise;
			int _bRise = nb6bushou[iBushouID].bRise;

			// [AQlɂ
			bool isRouninka = setGenekiToRounin(iBushouID);
			if (!isRouninka) { return false; }

			// ʒuړ
			bool isTranska = _setBushouTransportRonin(iBushouID, iNewCastleID);
			if (!isTranska) { return false; }

			bool isGenekika = setRouninToGeneki(iBushouID);
			// ɂłȂ炻̂܂ܘQlƂďIB(xzƂƁÂ܂ܘQl̂܂܂ƂȂB)
			if (!isGenekika) { return false; }

			// XȂ̂ŁAQlO̒lŕ̂߂B
			nb6bushou[iBushouID].merits = _merits; // M
			nb6bushouname[iBushouID].position = _position; // g
			nb6bushou[iBushouID].loyal = _loyal; // 
			nb6bushou[iBushouID].soldier = _soldier; // 
			nb6bushou[iBushouID].training = _training; // P
			nb6bushou[iBushouID].solloyal = _solloyal; // mC
			nb6bushou[iBushouID].form = _form; // 

											   // ]OƓ]ő喼ωĂȂꍇ̂݁AmNn̒l𕜌
			if (_attach == nb6bushou[iBushouID].attach) {
				nb6bushou[iBushouID].work = _work; // dN
				nb6bushou[iBushouID].rise = _rise; // 
				nb6bushou[iBushouID].bRise = _bRise; // 
			}
			else {
				nb6bushou[iBushouID].grudge = 0; // 喼ςꍇA݂͏
			}

		}
	}
	return false;
}


// ̏̏ƂB
// ́uv̕Ȁ̏ɂB
// ̏傪uRcvu喼vƁA̐l̗ƂȂB
bool setGenekiToJyosyu(int iBushouID) {

	if (0 <= iBushouID && iBushouID < GAMEDATASTRUCT_BUSHOU_NUM) {

		//0喼,1R,2
		if (nb6bushouname[iBushouID].State == 2) { // 𕐏̏ꍇB

												   // Y̋邪Ƃ񂪊i[ĂB([U[ɂĉĂȂ)
			int iCastleID = nb6bushou[iBushouID].castle - 1;

			if (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) {

				if (nb6castle[iCastleID].master == 0xFFFF) { return false; } // NXgĂ̂ɒNĂȂBȂBreturn;

																			 // ܂ŗ傪̂Łc
				int iJyosyuBushouID = nb6castle[iCastleID].master - 1;

				// w蕐łɏȂ牽ȂĂłB
				if (iBushouID == iJyosyuBushouID) { return true; }

				// ͋邪()Ȕjf[^ɂȂĂAȂB
				if (!(0 <= iJyosyuBushouID && iJyosyuBushouID < GAMEDATASTRUCT_BUSHOU_NUM)) {
					return false;
				}

				//0喼,1R,2

				// 傪łRcłȂȂ(喼)AȂBւƕςȂƂɂȂB
				// Ȃ
				if (nb6bushouname[iJyosyuBushouID].State == 2) {

					; // ɉȂ
					  // RcȂ
				}
				else if (nb6bushouname[iJyosyuBushouID].State == 1) {
					// ̌RcƂ
					nb6bushouname[iJyosyuBushouID].State = 2; // Ƃ

															  // tɎw蕐Rc
					nb6bushouname[iBushouID].State = 1; // Rc
					int iGundanID = nb6bushou[iJyosyuBushouID].gundan - 1;
					// ėvʔ̂͂ł邪ꉞ
					if (0 <= iGundanID && iGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {
						// RčRc̔ԍAw̕ɂB
						nb6gundan[iGundanID].leader = iBushouID + 1;
					}
					// 喼Ȃ΁c
				}
				else if (nb6bushouname[iJyosyuBushouID].State == 0) {
					// ̑喼Ƃ
					nb6bushouname[iJyosyuBushouID].State = 2;
					// 喼l̐ghVƂB
					nb6bushouname[iJyosyuBushouID].position = 2; //(B=0, 喼=1, hV=2, ƘV=3, =4, 叫=5, y=6)
																 // tɎw蕐喼Ƃ
					nb6bushouname[iBushouID].State = 0;
					nb6bushouname[iBushouID].position = 1;

					int iGundanID = nb6bushou[iJyosyuBushouID].gundan - 1;
					int iDaimyoID = nb6bushou[iJyosyuBushouID].attach - 1;
					// ėvʔ̂͂ł邪ꉞ
					if (0 <= iGundanID && iGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {
						// RčRc̔ԍAw̕ɂB
						nb6gundan[iGundanID].leader = iBushouID + 1;
					}
					if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {
						// nb6daimyȏ喼̔ԍAw̕ɂB
						nb6daimyo[iDaimyoID].attach = iBushouID + 1;
					}

				}
				else {
					return false;
				}




				/*̕Xg

				@ @
				   
				   ---

				   Ƃ̂

				   --

				   ƂB
				   */


				   // p[ẂA܏傾
				if (nb6castle[iCastleID].master - 1 == iBushouID) {
					nb6castle[iCastleID].master = nb6bushou[iBushouID].next; // nextɂB
				}

				// prev͗LȕB
				if (0 < nb6bushou[iBushouID].prev && nb6bushou[iBushouID].prev <= GAMEDATASTRUCT_BUSHOU_NUM) {

					// ł͂ȂŁA
					// PO̐l̎̃N悪g̏ꍇ
					if (nb6bushou[iBushouID].prev != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].prev - 1)].next == iBushouID + 1) {
						// ł͂ȂA̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].prev - 1)].next = nb6bushou[iBushouID].next;
					}
				}

				// next͗LȕB
				if (0 < nb6bushou[iBushouID].next && nb6bushou[iBushouID].next <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// P̐l̑ÕN悪g̏ꍇ
					if (nb6bushou[iBushouID].next != 0xFFFF && nb6bushou[(nb6bushou[iBushouID].next - 1)].prev == iBushouID + 1) {
						// ł͂ȂAO̐lւƌqB
						nb6bushou[(nb6bushou[iBushouID].next - 1)].prev = nb6bushou[iBushouID].prev;
					}
				}



				/* ̏僊Xg@

				-

				Ƃ̂

				--

				ƂB
				*/

				// ƂȂ̂ŁA̎̐lȀ̐lƂB
				int iJosyu = nb6castle[iCastleID].master;
				nb6bushou[iBushouID].next = iJosyu; // ݂̐擪̐l̎̐l

													// nextLȕȂ΁c
				if (0 < iJosyu && iJosyu <= GAMEDATASTRUCT_BUSHOU_NUM) {
					// ̐lprev
					nb6bushou[iJosyu - 1].prev = iBushouID + 1;
				}

				nb6bushou[iBushouID].prev = 0xFFFF; // {l擪ɂȂ̂ŁAprev͋Ȃ

													// čŌɎ
				nb6castle[iCastleID].master = iBushouID + 1; // ̏ɂB

				return true;
			}
		}
	}

	return false;
}



// ̗֔zB(vZp)
static int arrayAisho[32] = { 8,9,10,11,12,13,14,15,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,0,1,2,3,4,5,6,7 };

// AB̑̍𓾂
// ŏ0(ō) ő8(ň)
static int getAishoDiff(int iAishoA, int iAishoB) {

	// ܂AȂʒu𒆉
	int iAAishoIXInArray = 0;
	for (int iAishoID = 8; iAishoID<8 + GAMEDATASTRUCT_AISHOU_NUM; iAishoID++) {
		// ȂlAÄʒu
		if (arrayAisho[iAishoID] == iAishoA) {
			iAAishoIXInArray = iAishoID;
		}
	}

	// sȐ̏ꍇ́A͍ł̂ƂB
	if (iAAishoIXInArray == 0) { return 8; }

	// B̑ʒuA-8X^[g
	int iBAishoIXInArray = 0;
	for (int iAishoID = iAAishoIXInArray - 8; iAishoID<iAAishoIXInArray + 8; iAishoID++) {
		// ȂlAÄʒu
		if (arrayAisho[iAishoID] == iAishoB) {
			iBAishoIXInArray = iAishoID;
		}
	}

	// sȐ̏ꍇ́A͍ł̂ƂB
	if (iBAishoIXInArray == 0) { return 8; }

	// Q̑̈ʒu̍
	return abs(iBAishoIXInArray - iAAishoIXInArray);
}


/*
* 2l̕ID瑊̈Ⴂ𓾂B
* ŏ0(ō) ő8(ň)
*/
int getBushouAishoDiff(int iBushouAID, int iBushouBID) {
	// AB͈͓Ɏ܂Ă
	if (0 <= iBushouAID && iBushouAID < GAMEDATASTRUCT_BUSHOU_NUM && 0 <= iBushouBID && iBushouBID < GAMEDATASTRUCT_BUSHOU_NUM) {
		// ̑̍Ԃ
		return getAishoDiff(nb6bushou[iBushouAID].affinity, nb6bushou[iBushouBID].affinity);
	}
	// ԈlԂĂ
	else {
		return 8;
	}
}






